//+------------------------------------------------------------------+
//|                                                    GET LUCKY.mq4 |
//|                                 Copyright  2009, Pierre Mouawad |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Pierre Mouawad"

//---- input parameters
extern int       TakeProfit = 125;
extern double    Perc       = 3;     //--- Percentage of Account to invest
extern double    Lots       = 1;     //--- If Perc=0, Lots is Fixed to this amount
extern int       MaxTrades  = 4;     //--- Maximum Number of Trades to Open
extern int       Level      = 70;    //--- the level where the EA starts averaging
extern int       Slippage   = 10;
extern int       LotC       = 500;   //--- Lot Cost (based on margin requirement and type of account

int    TradeType=0, TradeCount=0;
double Lotsi=0, TradePrice=0, NewTarget=0, NewStop=0, AverageLong=0, AverageShort=0;
double x=0;

//+------------------------------------------------------------------+

int start()
   {
   
   double H, Hi, L, Lo, Cl, Clo1, Clo2, dm, sar, sar1, sar2;
  
   H    = High[0];
   Hi   = High[1];
   L    = Low[0];
   Lo   = Low[1];
   Cl   = Close[0];
   Clo1 = Close[1];
   Clo2 = Close[2];
   
   dm    = iDeMarker(NULL, 0, 12, 0);
   
   sar   = iSAR(NULL, 0, 0.003, 0.2, 0);
   sar1  = iSAR(NULL, 0, 0.003, 0.2, 1);
   sar2  = iSAR(NULL, 0, 0.003, 0.2, 2);

//-- check for open orders and their details
   int Total=OrdersTotal();
   if(TradeCount==MaxTrades && Total==0) TradeCount=0;
   for(int cnt=0; cnt<Total; cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS);
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)
         {
         TradeType=1;
         TradeCount++;
         TradePrice    = OrderOpenPrice();
         NewTarget     = OrderTakeProfit();
         NewStop       = OrderStopLoss();
         Lotsi         = OrderLots();
       
         if(TradeCount>1)
            {
            OrderSelect(cnt-1, SELECT_BY_POS);
            if(OrderTakeProfit() != NewTarget)
            OrderModify(OrderTicket(),OrderOpenPrice(),NewStop,NewTarget,0);
            }
         }
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)
         {
         TradeType=2;
         TradeCount++;
         TradePrice    = OrderOpenPrice();
         NewTarget     = OrderTakeProfit();
         NewStop       = OrderStopLoss();
         Lotsi         = OrderLots();
         
         if(TradeCount>1)
            {
            OrderSelect(cnt-1, SELECT_BY_POS);
            if(OrderTakeProfit() != NewTarget)
               OrderModify(OrderTicket(),OrderOpenPrice(),NewStop,NewTarget,0);
            }
         
         }
      }
      
   //-- Look for initial entries
   if(TradeCount==0) 
      {
      //-- Long
        if (Total==0 && x!=iTime(0,0,0) && Bid>Hi && (Bid-Hi)<(5*Point) 
                     && Bid>sar && Clo1>sar1 && Clo2>sar2 && dm<0.3 && Cl==H)
         {
         if (Perc!=0) Lots=NormalizeDouble((AccountBalance()*(Perc/100)/LotC),2);
               {if (Lots>6) Lots=6;}
         OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage, 0,
	                Ask+(TakeProfit*Point),"LONG Position Initiated",0,0,Navy);
         return(0);
         }
                       
      //-- Short
        if (Total==0 && x!=iTime(0,0,0) && Bid<Lo && (Lo-Bid)<(5*Point) 
                     && Bid<sar && Clo1<sar1 && Clo2<sar2 && dm>0.7 && Cl==L)
         {
         if (Perc!=0) Lots=NormalizeDouble((AccountBalance()*(Perc/100)/LotC),2);
               {if (Lots>6) Lots=6;}
         OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage, 0,
                   Bid-(TakeProfit*Point),"SHORT Position Initiated",0,0,Red);
         return(0);
         }
      }   
      
   //-- Average Positions
   
      //-- average long
      if(TradeCount>0 && TradeCount<MaxTrades && TradeType==1 && (TradePrice-Ask)>=Level*Point && Ask>sar)
              {
              Lotsi       = NormalizeDouble(Lotsi*2,2);
              AverageLong = (((MaxTrades-TradeCount)*Level)*Point);
                if(AverageLong<11*Point) AverageLong=11*Point;
      
              OrderSend(Symbol(),OP_BUY,Lotsi,Ask,Slippage, 0,
                        Ask+((TakeProfit)*Point),"LONG Averaging Initiated",0,0,Green);
              }
      
      //-- average short
      if(TradeCount>0 && TradeCount<MaxTrades && TradeType==2 && (Bid-TradePrice)>=Level*Point && Bid<sar)
              {
              Lotsi        = NormalizeDouble(Lotsi*2,2);
              AverageShort = (((MaxTrades-TradeCount)*Level)*Point);
              if(AverageShort<11*Point) AverageShort=11*Point;
      
              OrderSend(Symbol(),OP_SELL,Lotsi,Bid,Slippage, 0,
                        Bid-((TakeProfit)*Point),"SHORT Averaging Initiated",0,0,DarkOrchid);
              }
      
            
      TradeCount=0;
      
      return(0);
      }
//+------------------------------------------------------------------+